SystemOrganization addCategory: #'TADP-Meta1'!

Object subclass: #Alguna
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1'!

!Alguna methodsFor: 'as yet unclassified' stamp: ''!
intercepcion
	self antes.
	self interceptionVieja.
	self despues.! !

!Alguna methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 01:20'!
pasarMetodosDe: unaClase a: unTrait
 		
	(self metodosAinterceptarDe: unaClase)
		do: [:selector | unTrait compile: (unaClase >> selector) sourceCode.
				unaClase removeSelector: selector.].! !

Object subclass: #ClaseDelAnterior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1'!

Object subclass: #ClaseDelMetodo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1'!

Object subclass: #ClaseDelPosterior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1'!

Object subclass: #TheInterceptor
	instanceVariableNames: 'categoryClasses estrategia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1'!

TheInterceptor class
	instanceVariableNames: 'categoryClasses estrategia'!

TheInterceptor class
	instanceVariableNames: 'categoryClasses estrategia'!

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 02:17'!
categoryClasses
	^categoryClasses.! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 02:17'!
categoryClasses: unasClases 
	categoryClasses:=unasClases .! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 04:17'!
crearAliasAl: metodoAinterceptar De: unaClase
	^ (unaClase methodDictionary at: ( 'alias', metodoAinterceptar) asSymbol put: (unaClase >> metodoAinterceptar)).! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 04:20'!
decorarMetodo: metodoAinterceptar de: unaClase con: unMetodo y: otroMetodo

	ClaseDelAnterior compile: unMetodo.

	ClaseDelPosterior compile: otroMetodo.
	
	unaClase compile: unMetodo.
	
	unaClase compile: otroMetodo.

	(ClaseDelMetodo compile: 
		( metodoAinterceptar asString , '<n>' , (ClaseDelAnterior selectors at:1) asString, '<n>' ,
			(unaClase >> ( 'alias', metodoAinterceptar) asSymbol) getSource, (ClaseDelPosterior selectors at:1) asString)).
	
	unaClase methodDictionary at: metodoAinterceptar put: (ClaseDelMetodo selectors at: 1).! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 02:17'!
estrategia
	^estrategia.! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 02:17'!
estrategia: unBloque 
	estrategia:= unBloque.! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 04:06'!
initialize 
	self categoryClasses: Set new.! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 02:14'!
interceptame: unaCategoria poniendoAntes:unMetodo yDespues: otroMetodo

	(self obtenerCategoryClassesDe: unaCategoria) 
			do: [: unaClase | self interceptar: unaClase con: unMetodo y: otroMetodo].! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 04:20'!
interceptar: unaClase con: unMetodo y: otroMetodo
	(self metodosAinterceptarDe: unaClase)
		do: [ :metodoAinterceptar | 
			self crearAliasAl: metodoAinterceptar De: unaClase.
			self decorarMetodo: metodoAinterceptar de: unaClase con: unMetodo y: otroMetodo.
			self vaciarClases.].! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 02:13'!
metodosAinterceptarDe: unaClase

	^ ((unaClase selectors) select: self estrategia).! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 02:12'!
obtenerCategoryClassesDe: unaCategoria

	self categoryClasses: ((SystemOrganization listAtCategoryNamed: unaCategoria) 
							collect: [:each | Smalltalk globals at: each]).

	^ self categoryClasses.! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 03:55'!
vaciarClase: unaClase
		
	(unaClase selectors) do:[:unSelector | unaClase removeSelector: unSelector.].! !

!TheInterceptor class methodsFor: 'as yet unclassified' stamp: 'guiw5 5/4/2013 03:55'!
vaciarClases
	self vaciarClase: ClaseDelMetodo.
	self vaciarClase: ClaseDelAnterior.
	self vaciarClase: ClaseDelPosterior.
! !
TheInterceptor initialize!
